'use strict';

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _Promise = require('../../Promise');

var _Promise2 = _interopRequireDefault(_Promise);

var _Schema2 = require('../../Schema');

var _Schema3 = _interopRequireDefault(_Schema2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SqlSchema = (function (_Schema) {
  _inherits(SqlSchema, _Schema);

  function SqlSchema() {
    _classCallCheck(this, SqlSchema);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(SqlSchema).apply(this, arguments));
  }

  _createClass(SqlSchema, [{
    key: 'dropTable',
    value: function dropTable(collection) {
      var connection = this.getConnection();
      var table = collection.table;

      return new _Promise2.default(function (resolve, reject) {
        connection.schema.dropTableIfExists(table).then(function (response) {
          return resolve(response);
        }).catch(function (error) {
          reject(error);
        });
      });
    }
  }, {
    key: 'createTable',
    value: function createTable(collection) {
      var connection = this.getConnection();
      var table = collection.table;

      return new _Promise2.default(function (resolve, reject) {
        connection.schema.createTable(table, function (t) {
          _lodash2.default.each(collection.schema, function (column, name) {
            t[column.type](name);
          });
        }).then(function (response) {
          resolve(response);
        }).catch(function (error) {
          reject(error);
        });
      });
    }
  }]);

  return SqlSchema;
})(_Schema3.default);

exports.default = SqlSchema;